from fastapi.routing import APIRouter
from fastapi.requests import Request

from api_validations.validations_request import (
    PatchRecord,
    ListOptions,
    InsertBuildSites,
    UpdateBuildSites,
)

from api_services.redis.auth_actions.token import parse_token_object_to_dict


build_sites_route = APIRouter(prefix="/building/sites", tags=["Building Sites"])
build_sites_route.include_router(build_sites_route, include_in_schema=True)


@build_sites_route.post(path="/list", summary="List Active/Delete/Confirm Build Parts")
def building_sites_list(request: Request, list_options: ListOptions):
    token_dict = parse_token_object_to_dict(request=request)
    return token_dict.available_event(list_options=list_options, token_dict=token_dict)


@build_sites_route.post(
    path="/create", summary="Create Build Sites with given auth levels"
)
def building_sites_create(request: Request, data: InsertBuildSites):
    token_dict = parse_token_object_to_dict(request=request)
    return token_dict.available_event(data=data, token_dict=token_dict)


@build_sites_route.post(
    path="/update/{build_uu_id}", summary="Update Build Sites with given auth levels"
)
def building_sites_update(request: Request, build_uu_id: str, data: UpdateBuildSites):
    token_dict = parse_token_object_to_dict(request=request)
    return token_dict.available_event(
        data=data, build_uu_id=build_uu_id, token_dict=token_dict
    )


@build_sites_route.patch(
    path="/patch/{build_uu_id}", summary="Update Active/Delete/Confirm"
)
def building_sites_patch(request: Request, build_uu_id: str, data: PatchRecord):
    token_dict = parse_token_object_to_dict(request=request)
    return token_dict.available_event(
        data=data, build_uu_id=build_uu_id, token_dict=token_dict
    )
